MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sc::R12IntsAcc_MPIIOFile_Ind Class Reference
Inheritance diagram for sc::R12IntsAcc_MPIIOFile_Ind:
[legend]
Collaboration diagram for sc::R12IntsAcc_MPIIOFile_Ind:
[legend]

## Public Member Functions
| R12IntsAcc_MPIIOFile_Ind (Ref< MemoryGrp > &mem, const char *filename, int num_te_types, int ni, int nj, int nx, int ny)
| R12IntsAcc_MPIIOFile_Ind (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | store_memorygrp (Ref< MemoryGrp > &mem, int ni, const size_t blksize=0)
| Stores all pair block of integrals held in mem. More...
double * | retrieve_pair_block (int i, int j, tbint_type oper_type)
| Retrieves an ij pair block of integrals from the file.
Public Member Functions inherited from sc::R12IntsAcc_MPIIOFile
| R12IntsAcc_MPIIOFile (Ref< MemoryGrp > &mem, const char *filename, int num_te_types, int ni, int nj, int nx, int ny)
| R12IntsAcc_MPIIOFile (StateIn &)
void | store_pair_block (int i, int j, double *ints)
| Stores an ij pair block of integrals to the file.
void | commit ()
| Commit the content of the accumulator for reading - deactivate the associated MemoryGrp and activate the accumulator. More...
void | activate ()
| Call when ready to read content.
void | deactivate ()
| Done reading content - activate the associated MemoryGrp This is a collective operation.
void | release_pair_block (int i, int j, tbint_type oper_type)
| Releases an ij pair block of integrals.
bool | is_local (int i, int j) const
| Is this block stored locally?
bool | is_avail (int i, int j) const
| In this implementation blocks are available everywhere.
bool | has_access (int proc) const
| Does this task have access to all the integrals?
bool | can_restart () const
| Can restart MPI-IO-based accumulator.
int | ij_index (int i, int j) const
Public Member Functions inherited from sc::R12IntsAcc
| R12IntsAcc (int num_te_types, int ni, int nj, int nx, int ny)
| R12IntsAcc (StateIn &)
int | num_te_types () const
| The number of types of integrals that are being handled together.
int | ni () const
| Rank of index space i.
int | nj () const
| Rank of index space j.
int | nx () const
| Rank of index space x.
int | ny () const
| Rank of index space y.
size_t | blocksize () const
| Size of each block of the integrals of one type, in double words.
int | next_orbital () const
| The index of the first orbital in the next integrals batch to be stored.
bool | is_committed ()
| Has the content of the accumulator been commited for reading?
const bool | is_active ()
| Check if can read content.
int | tasks_with_access (vector< int > &twa_map) const
| Returns the total number of tasks with access to integrals. More...
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members
Public Types inherited from sc::R12IntsAcc
enum | tbint_type { eri =0, r12 =1, r12t1 =2, r12t2 =3 }
| Types of two-body operators that R12IntsAcc understands.
Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Static Public Attributes inherited from sc::R12IntsAcc
static const int | max_num_te_types_ = 4
Protected Member Functions inherited from sc::R12IntsAcc_MPIIOFile
void | check_error_code_ (int errcod) const
| Utility function to check MPI I/O error codes.
void | init (bool restart)
int | ntasks () const
| total number of tasks
int | taskid () const
| ID of this task.
Protected Attributes inherited from sc::R12IntsAcc_MPIIOFile
Ref< MemoryGrp > | mem_
int | nproc_
size_t | nints_per_block_
char * | filename_
MPI_File | datafile_
struct sc::R12IntsAcc_MPIIOFile::PairBlkInfo * | pairblk_

## Member Function Documentation

void sc::R12IntsAcc_MPIIOFile_Ind::save_data_state | ( | StateOut & |  | ) |
| virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::R12IntsAcc_MPIIOFile.

void sc::R12IntsAcc_MPIIOFile_Ind::store_memorygrp | ( | Ref< MemoryGrp > & | mem,
|  | int | ni,
|  | const size_t | blksize = `0`
| ) |  |
| virtual

Stores all pair block of integrals held in mem.

By default blocks are appended to the end of the same file, i.e. they are assumed to have come from consecutive passes of the same transformation. This is a collective operation. See documentation for R12IntsAcc::store_memorygrp() for more info.

Implements sc::R12IntsAcc.

The documentation for this class was generated from the following file:

- r12ia_mpiiofile.h